=== debian/changelog ===
mojoshader (0.0~hg1314+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload for testing migration. 

 -- Boyuan Yang <byang@debian.org>  Wed, 28 Oct 2020 10:30:51 -0400

mojoshader (0.0~hg1314+dfsg-1) unstable; urgency=medium

  * Initial Release (Closes: #972093)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 18 Oct 2020 01:40:23 +0800
