=== debian/control ===
Source: mojoshader
Section: libs
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgl-dev,
 libvulkan-dev,
 re2c,
 spirv-tools,
 libcryptx-perl,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://icculus.org/mojoshader/
Vcs-Browser: https://salsa.debian.org/yangfl-guest/mojoshader
Vcs-Git: https://salsa.debian.org/yangfl-guest/mojoshader.git

Package: libmojoshader-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmojoshader0 (= ${binary:Version})
Description: library to move calls to Direct3D shaders to OpenGL (development files)
 MojoShader is a library to work with Direct3D shaders on alternate 3D APIs and
 non-Windows platforms. The primary motivation is moving shaders to OpenGL
 languages on the fly. The developer deals with "profiles" that represent
 various target languages, such as GLSL or ARB_*_program.
 .
 This allows a developer to manage one set of shaders, presumably written in
 Direct3D HLSL, and use them across multiple rendering backends. This also means
 that the developer only has to worry about one (offline) compiler to manage
 program complexity, while MojoShader itself deals with the reduced complexity
 of the bytecode at runtime.
 .
 MojoShader provides both a simple API to convert bytecode to various profiles,
 and (optionally) basic glue to rendering APIs to abstract the management of the
 shaders at runtime.
 .
 This package contains the header files and static library for libmojoshader0.

Package: libmojoshader0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library to move calls to Direct3D shaders to OpenGL
 MojoShader is a library to work with Direct3D shaders on alternate 3D APIs and
 non-Windows platforms. The primary motivation is moving shaders to OpenGL
 languages on the fly. The developer deals with "profiles" that represent
 various target languages, such as GLSL or ARB_*_program.
 .
 This allows a developer to manage one set of shaders, presumably written in
 Direct3D HLSL, and use them across multiple rendering backends. This also means
 that the developer only has to worry about one (offline) compiler to manage
 program complexity, while MojoShader itself deals with the reduced complexity
 of the bytecode at runtime.
 .
 MojoShader provides both a simple API to convert bytecode to various profiles,
 and (optionally) basic glue to rendering APIs to abstract the management of the
 shaders at runtime.
