## mojoshader 0.0~hg1314+dfsg

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@

execute_after_dh_auto_clean:
	rm -f mojoshader_version.h mojoshader_parser_hlsl.h

override_dh_auto_configure:
	dh_auto_configure -- \
		-DMOJOSHADER_VERSION=1314 \
		-DMOJOSHADER_CHANGESET=hg-1314:3ddd9fca664f
