=== debian/watch ===
version=4
opts="searchmode=plain,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,repacksuffix=+dfsg,uversionmangle=s/^/0.0~hg/,downloadurlmangle=s%.*%nonexistant%" \
   https://hg.icculus.org/icculus/mojoshader/log \
   rev\s(\d+) debian uupdate
