## mojoshader 0.0~hg1314+git20250606.93d9d45+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,66 +1,73 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.12.0)
 PROJECT(MojoShader)
+
+# !!! FIXME: can we lowercase this file, if nothing else?
+
+INCLUDE(CheckIncludeFile)
+CHECK_INCLUDE_FILE(d3d11.h HAS_D3D11_H)
 
 OPTION(BUILD_SHARED_LIBS "Build MojoShader as a shared library" OFF)
 OPTION(PROFILE_D3D "Build MojoShader with support for the D3D profile" ON)
 OPTION(PROFILE_BYTECODE "Build MojoShader with support for the BYTECODE profile" ON)
-OPTION(PROFILE_HLSL "Build MojoShader with support for the HLSL profile" ON)
+OPTION(PROFILE_HLSL "Build MojoShader with support for the HLSL profile" HAS_D3D11_H)
 OPTION(PROFILE_GLSL120 "Build MojoShader with support for the GLSL120 profile" ON)
 OPTION(PROFILE_GLSLES "Build MojoShader with support for the GLSLES profile" ON)
 OPTION(PROFILE_GLSL "Build MojoShader with support for the GLSL profile" ON)
 OPTION(PROFILE_ARB1 "Build MojoShader with support for the ARB1 profile" ON)
 OPTION(PROFILE_ARB1_NV "Build MojoShader with support for the ARB1_NV profile" ON)
-OPTION(PROFILE_METAL "Build MojoShader with support for the Metal profile" ON)
+OPTION(PROFILE_METAL "Build MojoShader with support for the Metal profile" APPLE)
 OPTION(PROFILE_SPIRV "Build MojoShader with support for the SPIR-V profile" ON)
 OPTION(PROFILE_GLSPIRV "Build MojoShader with support for the ARB_gl_spirv profile" ON)
 OPTION(EFFECT_SUPPORT "Build MojoShader with support for Effect framework files" ON)
-OPTION(COMPILER_SUPPORT "Build MojoShader with support for HLSL source files" ON)
+OPTION(COMPILER_SUPPORT "Build MojoShader with support for HLSL source files" !WIN32) # TODO: Fix lemon on Windows
 OPTION(FLIP_VIEWPORT "Build MojoShader with the ability to flip the GL viewport" OFF)
 OPTION(DEPTH_CLIPPING "Build MojoShader with the ability to simulate [0, 1] depth clipping" OFF)
 OPTION(XNA4_VERTEXTEXTURE "Build MojoShader with XNA4 vertex texturing behavior" OFF)
 
 INCLUDE_DIRECTORIES(.)
 
-# If Mercurial is installed and we are in a mercurial repository, include the rev# and changeset as version information.
-FIND_PROGRAM(HG hg DOC "Path to hg command line app: http://www.selenic.com/mercurial/")
-IF(NOT HG)
-    MESSAGE(STATUS "Mercurial (hg) not found. You can go on, but version info will be wrong.")
-    SET(MOJOSHADER_VERSION -1)
+# This was a Mercurial thing. In Git, it's always -1.
+SET(MOJOSHADER_VERSION -1)
+
+# If Git is installed and we are in a git repository, include the changeset as version information.
+FIND_PROGRAM(GIT git DOC "Path to git command line app: https://git-scm.com/")
+IF(NOT GIT)
+    MESSAGE(STATUS "Git not found. You can go on, but version info will be wrong.")
     SET(MOJOSHADER_CHANGESET "???")
-ELSE(NOT HG)
-    MARK_AS_ADVANCED(HG)
-
-    # See if we are in an hg repository.
+ELSE(NOT GIT)
+    MARK_AS_ADVANCED(GIT)
+
+    # !!! FIXME: this didn't actually use the GIT variable...
+
+    # See if we are in a git repository.
     EXECUTE_PROCESS(
-        COMMAND hg root
+        COMMAND git rev-parse --show-toplevel
         WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
-        RESULT_VARIABLE HGVERSION_RC
+        OUTPUT_VARIABLE MOJOSHADER_GIT_TOPLEVEL_DIR
+        RESULT_VARIABLE GITVERSION_RC
         ERROR_QUIET
-    )
-    IF(NOT HGVERSION_RC EQUAL 0)
-        MESSAGE(STATUS "Mercurial (hg) repository not found. You can go on, but version info will be wrong.")
-        SET(MOJOSHADER_VERSION -1)
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+    )
+    IF(NOT GITVERSION_RC EQUAL 0)
+        MESSAGE(STATUS "Git repository not found. You can go on, but version info will be wrong.")
         SET(MOJOSHADER_CHANGESET "???")
-    ELSE(NOT HGVERSION_RC EQUAL 0)
-        # Query the rev and changeset.
+    ELSE(NOT GITVERSION_RC EQUAL 0)
+        # Query the changeset.
         EXECUTE_PROCESS(
-            COMMAND hg tip --template {rev}
+            COMMAND git rev-list HEAD~..
             WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
-            RESULT_VARIABLE HGVERSION_RC
-            OUTPUT_VARIABLE MOJOSHADER_VERSION
+            RESULT_VARIABLE GITVERSION_RC
+            OUTPUT_VARIABLE MOJOSHADER_GIT_CHANGESET
             ERROR_QUIET
             OUTPUT_STRIP_TRAILING_WHITESPACE
         )
-        EXECUTE_PROCESS(
-            COMMAND hg tip --template hg-{rev}:{node|short}
-            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
-            RESULT_VARIABLE HGVERSION_RC
-            OUTPUT_VARIABLE MOJOSHADER_CHANGESET
-            ERROR_QUIET
-            OUTPUT_STRIP_TRAILING_WHITESPACE
-        )
-    ENDIF(NOT HGVERSION_RC EQUAL 0)
-ENDIF(NOT HG)
+        IF(NOT GITVERSION_RC EQUAL 0)
+            SET(MOJOSHADER_CHANGESET "???")
+        ELSE(NOT GITVERSION_RC EQUAL 0)
+            SET(MOJOSHADER_CHANGESET "git-${MOJOSHADER_GIT_CHANGESET}")
+        ENDIF(NOT GITVERSION_RC EQUAL 0)
+    ENDIF(NOT GITVERSION_RC EQUAL 0)
+ENDIF(NOT GIT)
 
 WRITE_FILE(
     "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_version.h"
@@ -87,12 +94,11 @@
 # We build lemon, then use it to generate parser C code.
 IF(COMPILER_SUPPORT)
     ADD_EXECUTABLE(lemon "misc/lemon.c")
-    GET_TARGET_PROPERTY(LEMON lemon LOCATION)
     ADD_CUSTOM_COMMAND(
         OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.h"
         MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.lemon"
         DEPENDS lemon "${CMAKE_CURRENT_SOURCE_DIR}/misc/lempar.c"
-        COMMAND "${LEMON}"
+        COMMAND lemon
         ARGS -q "-T${CMAKE_CURRENT_SOURCE_DIR}/misc/lempar.c" "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.lemon"
     )
 ENDIF(COMPILER_SUPPORT)
@@ -118,6 +124,9 @@
 IF(NOT PROFILE_GLSLES)
     ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSLES=0)
 ENDIF(NOT PROFILE_GLSLES)
+IF(NOT PROFILE_GLSLES3)
+    ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSLES3=0)
+ENDIF(NOT PROFILE_GLSLES3)
 IF(NOT PROFILE_GLSL)
     ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSL=0)
 ENDIF(NOT PROFILE_GLSL)
@@ -162,9 +171,8 @@
     mojoshader.c
     mojoshader_common.c
     mojoshader_opengl.c
-    mojoshader_metal.c
     mojoshader_d3d11.c
-    mojoshader_vulkan.c
+    mojoshader_sdlgpu.c
     profiles/mojoshader_profile_arb1.c
     profiles/mojoshader_profile_bytecode.c
     profiles/mojoshader_profile_d3d.c
@@ -191,8 +199,11 @@
     TARGET_LINK_LIBRARIES(mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
 ENDIF(BUILD_SHARED_LIBS)
 
+# These are fallback paths for D3D11, try to have this on the system instead!
 TARGET_INCLUDE_DIRECTORIES(mojoshader PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../Vulkan-Headers/include>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dxvk-native/include/native/directx>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dxvk-native/include/native/windows>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dxvk-native/include/native/wsi>
 )
 
 SET_SOURCE_FILES_PROPERTIES(
@@ -213,29 +224,30 @@
     )
 ENDIF(NOT RE2C)
 
-find_path(SDL2_INCLUDE_DIR SDL.h PATH_SUFFIXES include/SDL2)
-find_library(SDL2 NAMES SDL2 PATH_SUFFIXES lib)
-IF(SDL2)
-    INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIR})
+find_package(SDL2)
+IF(SDL2_FOUND)
+    INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIRS})
     ADD_EXECUTABLE(glcaps utils/glcaps.c)
-    TARGET_LINK_LIBRARIES(glcaps ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    TARGET_LINK_LIBRARIES(glcaps ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
     ADD_EXECUTABLE(bestprofile utils/bestprofile.c)
-    TARGET_LINK_LIBRARIES(bestprofile mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    TARGET_LINK_LIBRARIES(bestprofile mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
     ADD_EXECUTABLE(availableprofiles utils/availableprofiles.c)
-    TARGET_LINK_LIBRARIES(availableprofiles mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    TARGET_LINK_LIBRARIES(availableprofiles mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
     ADD_EXECUTABLE(testglcompile utils/testglcompile.c)
-    TARGET_LINK_LIBRARIES(testglcompile mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
-ENDIF(SDL2)
+    TARGET_LINK_LIBRARIES(testglcompile mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+ENDIF(SDL2_FOUND)
 
 IF(COMPILER_SUPPORT)
     ADD_EXECUTABLE(finderrors utils/finderrors.c)
-    TARGET_LINK_LIBRARIES(finderrors mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
-    IF(SDL2)
+    IF(SDL2_FOUND)
+        TARGET_LINK_LIBRARIES(finderrors mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
         SET_SOURCE_FILES_PROPERTIES(
             utils/finderrors.c
             PROPERTIES COMPILE_FLAGS "-DFINDERRORS_COMPILE_SHADERS=1"
         )
-    ENDIF(SDL2)
+    ELSE(SDL2_FOUND)
+        TARGET_LINK_LIBRARIES(finderrors mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    ENDIF(SDL2_FOUND)
 ENDIF(COMPILER_SUPPORT)
 
 FIND_PATH(SPIRV_TOOLS_INCLUDE_DIR "spirv-tools/libspirv.h" PATH_SUFFIXES "include")
