=== debian/changelog ===
mojoshader (0.0~hg1314+git20250606.93d9d45+dfsg-1) unstable; urgency=medium

  * New upstream snapshot
    * Fix FTBFS on architectures where char is unsigned
      (Closes: #976553)
    * Require libsdl2-dev (Closes: #991343)
    * Fix FTBFS with GCC-15 (Closes: #1097408)
    * Fix FTBFS with CMake 4 (Closes: #1113292)
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Sat, 06 Sep 2025 23:47:24 +0800
