=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
  debhelper-compat (= 13),
  cmake,
  libgl-dev,
+ libsdl2-dev,
  libvulkan-dev,
  re2c,
  spirv-tools,
  libcryptx-perl,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Homepage: https://icculus.org/mojoshader/
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/mojoshader
 Vcs-Git: https://salsa.debian.org/yangfl-guest/mojoshader.git
@@ -41,6 +42,7 @@
 
 Package: libmojoshader0
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: library to move calls to Direct3D shaders to OpenGL
  MojoShader is a library to work with Direct3D shaders on alternate 3D APIs and
