=== debian/rules ===
--- 
+++ 
@@ -16,5 +16,5 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DMOJOSHADER_VERSION=1314 \
-		-DMOJOSHADER_CHANGESET=hg-1314:3ddd9fca664f
+		-DMOJOSHADER_CHANGESET=git-93d9d45e6d645150195ea1a74a1654e4a1542c52 \
+		-DCOMPILER_SUPPORT=ON
