=== debian/watch ===
Version: 5
Source: https://github.com/icculus/mojoshader
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 0.0~hg1314+git%cd.%h
Dversion-Mangle: s/\+dfsg\d*$//
Repacksuffix: +dfsg
